#!/usr/bin/python
#note, columns in 'output.txt' as follows: pi	ss	D	thetaH	H
import math 
import random
import os

#draws from the prior distribution 
Priorsize = 100000

Counter = 0

#number of total samples in the data set
Nsam_Microtus = 58

#populations as follows - always numbered Inland = 1, Coastal = 2
#sample sizes for Microtus
#Inland = 34
#Coastal = 24


#while loop iterates draws from the prior for this model
while Counter <= Priorsize:
	Model = random.randint(0,3)
	ThetaAncestral = random.uniform(0.1, 10)
	

	#Divergence time is modeled in 4No generation
	DivergenceTime = random.uniform(.1, 3)
	DivergenceTime_AV = random.uniform(1, 30)

	MigrationRate = random.uniform(1,10)
	MigrationRate_Inland = random.uniform(1,10)
	MigrationRate_Coastal = random.uniform(1,10)

	if Model == 1:	
	# migration coastal to inland
		os.system("./ms %s 1 -t %f -I 2 34 24 -m 1 2 0 -m 2 1 %f -ej %f 1 2| ./msSS.pl >> mic.output.txt" % (Nsam_Microtus, ThetaAncestral, MigrationRate_Coastal, DivergenceTime))
		print '%s\t%f\t%f\tNA\tNA\t%f' % (Model, ThetaAncestral, DivergenceTime, MigrationRate_Coastal)
		Counter += 1

	elif Model == 2:	
	# migration inland to coastal
		os.system("./ms %s 1 -t %f -I 2 34 24 -m 1 2 %f -m 2 1 0 -ej %f 1 2| ./msSS.pl >> mic.output.txt" % (Nsam_Microtus, ThetaAncestral, MigrationRate_Inland, DivergenceTime))
		print '%s\t%f\t%f\tNA\t%f\tNA' % (Model, ThetaAncestral, DivergenceTime, MigrationRate_Inland)
		Counter += 1

	elif Model == 3:	
	#symmetrical migration
		os.system("./ms %s 1 -t %f -I 2 34 24 %f -ej %f 1 2| ./msSS.pl >> mic.output.txt" % (Nsam_Microtus, ThetaAncestral, MigrationRate, DivergenceTime_AV))
		print '%s\t%f\t%f\t%f\tNA\tNA' % (Model, ThetaAncestral, DivergenceTime_AV, MigrationRate)
		Counter += 1
