#!/usr/bin/python
#note, columns in 'output.txt' as follows: pi	ss	D	thetaH	H
# python plethodon.py > plethodon_prior.txt
import math 
import random
import os

#draws from the prior distribution 
Priorsize = 100000

Counter = 0

#number of total samples in the data set
Nsam_l1 = 72 #c31c32
Nsam_l2 = 40 #c109c110
Nsam_l3 = 265 #cytb
Nsam_l4 = 70 #gapd
Nsam_l5 = 72 #rag1
# number of inland samples for each locus
Inland_l1 = 38
Inland_l2 = 22
Inland_l3 = 229
Inland_l4 = 40
Inland_l5 = 42
# number of coastal samples for each locus
Coastal_l1 = 34
Coastal_l2 = 18
Coastal_l3 = 36
Coastal_l4 = 30
Coastal_l5 = 30


#while loop iterates draws from the prior for this model
while Counter <= Priorsize:
	Model = random.randint(0,3)
	ThetaAncestral = random.uniform(0.1, 20)
	

	#Divergence time is modeled in 4No generation
	DivergenceTime = random.uniform(.1, 3)
	DivergenceTime_AV = random.uniform(1, 30)

	MigrationRate = random.uniform(1,10)
	MigrationRate_Inland = random.uniform(1,10)
	MigrationRate_Coastal = random.uniform(1,10)
	
	if Model == 1:	
	# migration coastal to inland
		os.system("./ms 72 1 -t %f -I 2 38 34 -m 1 2 0 -m 2 1 %f -ej %f 1 2| ./msSS.pl >> plethodon1.output.txt" % (ThetaAncestral, MigrationRate_Coastal, DivergenceTime))
		os.system("./ms 40 1 -t %f -I 2 22 18 -m 1 2 0 -m 2 1 %f -ej %f 1 2| ./msSS.pl >> plethodon2.output.txt" % (ThetaAncestral, MigrationRate_Coastal, DivergenceTime))
		os.system("./ms 265 1 -t %f/2 -I 2 229 36 -m 1 2 0 -m 2 1 %f -ej %f 1 2| ./msSS.pl >> plethodon3.output.txt" % (ThetaAncestral, MigrationRate_Coastal, DivergenceTime))
		os.system("./ms 70 1 -t %f -I 2 40 30 -m 1 2 0 -m 2 1 %f -ej %f 1 2| ./msSS.pl >> plethodon4.output.txt" % (ThetaAncestral, MigrationRate_Coastal, DivergenceTime))
		os.system("./ms 72 1 -t %f -I 2 42 30 -m 1 2 0 -m 2 1 %f -ej %f 1 2| ./msSS.pl >> plethodon5.output.txt" % (ThetaAncestral, MigrationRate_Coastal, DivergenceTime))
		print '%s\t%f\t%f\tNA\tNA\t%f' % (Model, ThetaAncestral, DivergenceTime, MigrationRate_Coastal)
		Counter += 1

	elif Model == 2:	
	#migration inland to coastal
		os.system("./ms 72 1 -t %f -I 2 38 34 -m 1 2 %f -m 2 1 0 -ej %f 1 2| ./msSS.pl >> plethodon1.output.txt" % (ThetaAncestral, MigrationRate_Inland, DivergenceTime))
		os.system("./ms 40 1 -t %f -I 2 22 18 -m 1 2 %f -m 2 1 0 -ej %f 1 2| ./msSS.pl >> plethodon2.output.txt" % (ThetaAncestral, MigrationRate_Inland, DivergenceTime))
		os.system("./ms 265 1 -t %f/2 -I 2 229 36 -m 1 2 %f -m 2 1 0 -ej %f 1 2| ./msSS.pl >> plethodon3.output.txt" % (ThetaAncestral, MigrationRate_Inland, DivergenceTime))
		os.system("./ms 70 1 -t %f -I 2 40 30 -m 1 2 %f -m 2 1 0 -ej %f 1 2| ./msSS.pl >> plethodon4.output.txt" % (ThetaAncestral, MigrationRate_Inland, DivergenceTime))
		os.system("./ms 72 1 -t %f -I 2 42 30 -m 1 2 %f -m 2 1 0 -ej %f 1 2| ./msSS.pl >> plethodon5.output.txt" % (ThetaAncestral, MigrationRate_Inland, DivergenceTime))
		print '%s\t%f\t%f\tNA\t%f\tNA' % (Model, ThetaAncestral, DivergenceTime, MigrationRate_Inland)
		Counter += 1


	elif Model == 3:
	#symmetrical migration
		os.system("./ms 72 1 -t %f -I 2 38 34 %f -ej %f 1 2| ./msSS.pl >> plethodon1.output.txt" % (ThetaAncestral, MigrationRate, DivergenceTime_AV))
		os.system("./ms 40 1 -t %f -I 2 22 18 %f -ej %f 1 2| ./msSS.pl >> plethodon2.output.txt" % (ThetaAncestral, MigrationRate, DivergenceTime_AV))
		os.system("./ms 265 1 -t %f/2 -I 2 229 36  %f -ej %f 1 2| ./msSS.pl >> plethodon3.output.txt" % (ThetaAncestral, MigrationRate, DivergenceTime_AV))
		os.system("./ms 70 1 -t %f -I 2 40 30 %f -ej %f 1 2| ./msSS.pl >> plethodon4.output.txt" % (ThetaAncestral, MigrationRate, DivergenceTime_AV))
		os.system("./ms 72 1 -t %f -I 2 42 30  %f -ej %f 1 2| ./msSS.pl >> plethodon5.output.txt" % (ThetaAncestral, MigrationRate, DivergenceTime_AV))
		print '%s\t%f\t%f\t%f\t0\t0' % (Model, ThetaAncestral, DivergenceTime_AV, MigrationRate)
		Counter += 1
