#!/usr/bin/python
#note, columns in 'output.txt' as follows: pi	ss	D	thetaH	H
import math 
import random
import os

#draws from the prior distribution 
Priorsize = 100000

Counter = 0

#number of total samples in the data set
Nsam_l1 = 242 #15int6
Nsam_l2 = 196 #GLB1
Nsam_l3 = 174 #LFY
Nsam_l4 = 121 #matK
Nsam_l5 = 210 #NRPB2

Inland_l1 = 190
Inland_l2 = 148
Inland_l3 = 150
Inland_l4 = 94
Inland_l5 = 166

Coastal_l1 = 52
Coastal_l2 = 48
Coastal_l3 = 24
Coastal_l4 = 27
Coastal_l5 = 44


#while loop iterates draws from the prior for this model
while Counter <= Priorsize:
	Model = random.randint(0,3)
	ThetaAncestral = random.uniform(0.1, 10)
	

	#Divergence time is modeled in 4No generation
	DivergenceTime = random.uniform(.1, 3)
	DivergenceTime_AV = random.uniform(1, 30)

	MigrationRate = random.uniform(1,10)
	MigrationRate_Inland = random.uniform(1,10)
	MigrationRate_Coastal = random.uniform(1,10)

		



	if Model == 1:	
	# migration coastal to inland
		os.system("./ms 242 1 -t %f -I 2 190 52 -m 1 2 0 -m 2 1 %f -ej %f 1 2| ./msSS.pl >> salix1.output.txt" % (ThetaAncestral, MigrationRate_Coastal, DivergenceTime))
		os.system("./ms 196 1 -t %f -I 2 148 48 -m 1 2 0 -m 2 1 %f -ej %f 1 2| ./msSS.pl >> salix2.output.txt" % (ThetaAncestral, MigrationRate_Coastal, DivergenceTime))
		os.system("./ms 174 1 -t %f -I 2 150 24 -m 1 2 0 -m 2 1 %f -ej %f 1 2| ./msSS.pl >> salix3.output.txt" % (ThetaAncestral, MigrationRate_Coastal, DivergenceTime))
		os.system("./ms 121 1 -t %f/2 -I 2 94 27 -m 1 2 0 -m 2 1 %f -ej %f 1 2| ./msSS.pl >> salix4.output.txt" % (ThetaAncestral, MigrationRate_Coastal, DivergenceTime))
		os.system("./ms 210 1 -t %f -I 2 166 44 -m 1 2 0 -m 2 1 %f -ej %f 1 2| ./msSS.pl >> salix5.output.txt" % (ThetaAncestral, MigrationRate_Coastal, DivergenceTime))
		print '%s\t%f\t%f\tNA\tNA\t%f' % (Model, ThetaAncestral, DivergenceTime, MigrationRate_Coastal)
		Counter += 1
	
	elif Model == 2:	
	# migration inland to coastal
		os.system("./ms 242 1 -t %f -I 2 190 52 -m 1 2 %f -m 2 1 0 -ej %f 1 2| ./msSS.pl >> salix1.output.txt" % (ThetaAncestral, MigrationRate_Inland, DivergenceTime))
		os.system("./ms 196 1 -t %f -I 2 148 48 -m 1 2 %f -m 2 1 0 -ej %f 1 2| ./msSS.pl >> salix2.output.txt" % (ThetaAncestral, MigrationRate_Inland, DivergenceTime))
		os.system("./ms 174 1 -t %f -I 2 150 24 -m 1 2 %f -m 2 1 0 -ej %f 1 2| ./msSS.pl >> salix3.output.txt" % (ThetaAncestral, MigrationRate_Inland, DivergenceTime))
		os.system("./ms 121 1 -t %f/2 -I 2 94 27 -m 1 2 %f -m 2 1 0 -ej %f 1 2| ./msSS.pl >> salix4.output.txt" % (ThetaAncestral, MigrationRate_Inland, DivergenceTime))
		os.system("./ms 210 1 -t %f -I 2 166 44 -m 1 2 %f -m 2 1 0 -ej %f 1 2| ./msSS.pl >> salix5.output.txt" % (ThetaAncestral, MigrationRate_Inland, DivergenceTime))
		print '%s\t%f\t%f\tNA\t%f\tNA' % (Model, ThetaAncestral, DivergenceTime, MigrationRate_Inland)
		Counter += 1


	elif Model == 3:	
	#symmetrical migration
		os.system("./ms 242 1 -t %f -I 2 190 52 %f -ej %f 1 2| ./msSS.pl >> salix1.output.txt" % (ThetaAncestral, MigrationRate, DivergenceTime_AV))
		os.system("./ms 196 1 -t %f -I 2 148 48 %f -ej %f 1 2| ./msSS.pl >> salix2.output.txt" % (ThetaAncestral, MigrationRate, DivergenceTime_AV))
		os.system("./ms 174 1 -t %f -I 2 150 24 %f -ej %f 1 2| ./msSS.pl >> salix3.output.txt" % (ThetaAncestral, MigrationRate, DivergenceTime_AV))
		os.system("./ms 121 1 -t %f/2 -I 2 94 27 %f -ej %f 1 2| ./msSS.pl >> salix4.output.txt" % (ThetaAncestral, MigrationRate, DivergenceTime_AV))
		os.system("./ms 210 1 -t %f -I 2 166 44 %f -ej %f 1 2| ./msSS.pl >> salix5.output.txt" % (ThetaAncestral, MigrationRate, DivergenceTime_AV))
		print '%s\t%f\t%f\t%f\t0\t0' % (Model, ThetaAncestral, DivergenceTime_AV, MigrationRate)
		Counter += 1


