###this is to predict the type for unknown species

#load packages we will need
library(biomod2)
library(rworldmap)
library(rgdal) 
library(dismo)
library(SDMTools)
library(adehabitat)
library(randomForest)
library(MASS)

#if installation of rgdal doesn't work, in ubuntu 14.04 and debian, run in terminal
#sudo apt-get install libproj-dev libgdal-dev and then try to reinstall
#
#

#setwd("E:/collaborations/jack/R")
setwd("/mnt/gfs/anahi/jack")


#load bioclim data and then select the area that will be used to project
bio1=raster("./cur_climate/bio1.bil") #Annual Mean Temperature
bio2=raster("./cur_climate/bio2.bil")
bio3=raster("./cur_climate/bio3.bil")
bio4=raster("./cur_climate/bio4.bil")
bio5=raster("./cur_climate/bio5.bil")
bio6=raster("./cur_climate/bio6.bil")
bio7=raster("./cur_climate/bio7.bil")
bio8=raster("./cur_climate/bio8.bil")
bio9=raster("./cur_climate/bio9.bil")
bio10=raster("./cur_climate/bio10.bil") #Mean Temperature of Warmest Quarter 
bio11=raster("./cur_climate/bio11.bil") #Mean Temperature of Coldest Quarter
bio12=raster("./cur_climate/bio12.bil") #Annual Precipitation
bio13=raster("./cur_climate/bio13.bil")
bio14=raster("./cur_climate/bio14.bil")
bio15=raster("./cur_climate/bio15.bil")
bio16=raster("./cur_climate/bio16.bil")
bio17=raster("./cur_climate/bio17.bil")
bio18=raster("./cur_climate/bio18.bil") #Precipitation of Warmest Quarter
bio19=raster("./cur_climate/bio19.bil") #Precipitation of Coldest Quarter

#setwd("E:/collaborations/jack/R")
setwd("/mnt/gfs/anahi/jack/PNW")
clim=read.table("data_DFA.csv", header=T, sep=",")

PNWdata=cbind((as.matrix(extract(bio1,clim[,2:3]))),clim)
PNWdata=cbind((as.matrix(extract(bio2,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio3,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio4,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio5,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio6,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio7,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio8,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio9,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio10,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio11,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio12,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio13,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio14,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio15,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio16,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio17,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio18,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio19,clim[,2:3]))),PNWdata)

newcols=c("bio19","bio18","bio17","bio16","bio15","bio14","bio13","bio12","bio11","bio10","bio9","bio8",
          "bio7","bio6","bio5","bio4","bio3","bio2","bio1",colnames(clim))
colnames(PNWdata)<-newcols
#write.table(PNWdata, file="PNWdata_full.csv", sep=",")



#adjust the RF and downsample
#setwd("E:/collaborations/jack/R/testAccuracy/DFAPNWDownsample100")
setwd("/mnt/gfs/anahi/jack/PNW/DFAPNWDownsample100")
binded.Predict=c()
for (i in 1:100) {
PNWRF=c()
fitRFPNW=c()
PNWRF=PNWdata[PNWdata$complex!="Ascaphus.montanus.truei",]
C=PNWRF[PNWRF$group=="C",]
Csel=C[(sample(nrow(C), size=567, replace=T)),]
NC=PNWRF[PNWRF$group=="NC",]
PNWRF=rbind(Csel,NC)

fitDFAarid <- lda(group ~ bio1 + bio2 + bio3 + bio5 + bio7 + bio12 + bio15 + bio17 + taxon,
                         data=PNWRF)


Contribution=(fitDFAarid[[4]])
write.table(Contribution,file="fitDFAPNWDownsample.csv", sep=",", append=T)

fit.hatarid=predict(fitDFAarid)
binded.dataArid=c()
binded.dataArid=cbind(PNWRF, fit.hatarid$posterior) # bind initial data table with predicted values
write.table(binded.dataArid,file="bindedDataDFAPNWDownsample.csv",sep=",", append=T)

ctarid <- table(binded.dataArid$group, fit.hatarid$class)
diag(prop.table(ctarid, 1))
write.table(ctarid, file="confusionTableDFA_PNWDownsample.csv", sep=",",append=T)

Species=PNWdata[PNWdata$complex=="Ascaphus.montanus.truei",]
PredictionNEWprob <- predict(fitDFAarid,Species,type="prob") #calculates probability for each group
PredictionNEW <- predict(fitDFAarid,Species)
binded.dataRFPNW=cbind(Species, PredictionNEWprob,PredictionNEW)
binded.Predict=rbind(binded.dataRFPNW,binded.Predict)
write.table(binded.Predict[,c(20,32,34:36)], file="PredictDFAPNWDownOutsp.csv", sep=',', append=T)

}

####################
binded.Predict=c()
for (i in 1:100) {
  
PNWRF=c()
PNWRF=PNWdata[PNWdata$complex!="Conaphe.armataEW",]
C=PNWRF[PNWRF$group=="C",]
Csel=C[(sample(nrow(C), size=567, replace=T)),]
NC=PNWRF[PNWRF$group=="NC",]
PNWRF=rbind(Csel,NC)

fitDFAarid <- lda(group ~ bio1 + bio2 + bio3 + bio5 + bio7 + bio12 + bio15 + bio17 + taxon,
                  data=PNWRF)


Contribution=(fitDFAarid[[4]])
write.table(Contribution,file="fitDFAPNWDownsample.csv", sep=",", append=T)

fit.hatarid=predict(fitDFAarid)
binded.dataArid=c()
binded.dataArid=cbind(PNWRF, fit.hatarid$posterior) # bind initial data table with predicted values
write.table(binded.dataArid,file="bindedDataDFAPNWDownsample.csv",sep=",", append=T)

ctarid <- table(binded.dataArid$group, fit.hatarid$class)
diag(prop.table(ctarid, 1))
write.table(ctarid, file="confusionTableDFA_PNWDownsample.csv", sep=",",append=T)

Species=PNWdata[PNWdata$complex=="Conaphe.armataEW",]
PredictionNEWprob <- predict(fitDFAarid,Species,type="prob") #calculates probability for each group
PredictionNEW <- predict(fitDFAarid,Species)
binded.dataRFPNW=cbind(Species, PredictionNEWprob,PredictionNEW)
binded.Predict=rbind(binded.dataRFPNW,binded.Predict)
write.table(binded.Predict[,c(20,32,34:36)], file="PredictDFAPNWDownOutsp.csv", sep=',', append=T)
}

####################
binded.Predict=c()
for (i in 1:100) {
  
PNWRF=c()
PNWRF=PNWdata[PNWdata$complex!="Dicamptodon.ater.tene",]
C=PNWRF[PNWRF$group=="C",]
Csel=C[(sample(nrow(C), size=567, replace=T)),]
NC=PNWRF[PNWRF$group=="NC",]
PNWRF=rbind(Csel,NC)


fitDFAarid <- lda(group ~ bio1 + bio2 + bio3 + bio5 + bio7 + bio12 + bio15 + bio17 + taxon,
                  data=PNWRF)


Contribution=(fitDFAarid[[4]])
write.table(Contribution,file="fitDFAPNWDownsample.csv", sep=",", append=T)

fit.hatarid=predict(fitDFAarid)
binded.dataArid=c()
binded.dataArid=cbind(PNWRF, fit.hatarid$posterior) # bind initial data table with predicted values
write.table(binded.dataArid,file="bindedDataDFAPNWDownsample.csv",sep=",", append=T)

ctarid <- table(binded.dataArid$group, fit.hatarid$class)
diag(prop.table(ctarid, 1))
write.table(ctarid, file="confusionTableDFA_PNWDownsample.csv", sep=",",append=T)
Species=PNWdata[PNWdata$complex=="Dicamptodon.ater.tene",]
PredictionNEWprob <- predict(fitDFAarid,Species,type="prob") #calculates probability for each group
PredictionNEW <- predict(fitDFAarid,Species)
binded.dataRFPNW=cbind(Species, PredictionNEWprob,PredictionNEW)
binded.Predict=rbind(binded.dataRFPNW,binded.Predict)
write.table(binded.Predict[,c(20,32,34:36)], file="PredictDFAPNWDownOutsp.csv", sep=',', append=T)

}

####################
binded.Predict=c()
for (i in 1:100) {
  
PNWRF=c()
PNWRF=PNWdata[PNWdata$complex!="Microtus.richardsoni",]
C=PNWRF[PNWRF$group=="C",]
Csel=C[(sample(nrow(C), size=377, replace=T)),]
NC=PNWRF[PNWRF$group=="NC",]
PNWRF=rbind(Csel,NC)

fitDFAarid <- lda(group ~ bio1 + bio2 + bio3 + bio5 + bio7 + bio12 + bio15 + bio17 + taxon,
                  data=PNWRF)


Contribution=(fitDFAarid[[4]])
write.table(Contribution,file="fitDFAPNWDownsample.csv", sep=",", append=T)

fit.hatarid=predict(fitDFAarid)
binded.dataArid=c()
binded.dataArid=cbind(PNWRF, fit.hatarid$posterior) # bind initial data table with predicted values
write.table(binded.dataArid,file="bindedDataDFAPNWDownsample.csv",sep=",", append=T)

ctarid <- table(binded.dataArid$group, fit.hatarid$class)
diag(prop.table(ctarid, 1))
write.table(ctarid, file="confusionTableDFA_PNWDownsample.csv", sep=",",append=T)

Species=PNWdata[PNWdata$complex=="Microtus.richardsoni",]
PredictionNEWprob <- predict(fitDFAarid,Species,type="prob") #calculates probability for each group
PredictionNEW <- predict(fitDFAarid,Species)
binded.dataRFPNW=cbind(Species, PredictionNEWprob,PredictionNEW)
binded.Predict=rbind(binded.dataRFPNW,binded.Predict)
write.table(binded.Predict[,c(20,32,34:36)], file="PredictDFAPNWDownOutsp.csv", sep=',', append=T)

}

####################
binded.Predict=c()
for (i in 1:100) {
  
PNWRF=c()
PNWRF=PNWdata[PNWdata$complex!="Plethodon.idaho.vandy",]
C=PNWRF[PNWRF$group=="C",]
Csel=C[(sample(nrow(C), size=567, replace=T)),]
NC=PNWRF[PNWRF$group=="NC",]
PNWRF=rbind(Csel,NC)


fitDFAarid <- lda(group ~ bio1 + bio2 + bio3 + bio5 + bio7 + bio12 + bio15 + bio17 + taxon,
                  data=PNWRF)


Contribution=(fitDFAarid[[4]])
write.table(Contribution,file="fitDFAPNWDownsample.csv", sep=",", append=T)

fit.hatarid=predict(fitDFAarid)
binded.dataArid=c()
binded.dataArid=cbind(PNWRF, fit.hatarid$posterior) # bind initial data table with predicted values
write.table(binded.dataArid,file="bindedDataDFAPNWDownsample.csv",sep=",", append=T)

ctarid <- table(binded.dataArid$group, fit.hatarid$class)
diag(prop.table(ctarid, 1))
write.table(ctarid, file="confusionTableDFA_PNWDownsample.csv", sep=",",append=T)

Species=PNWdata[PNWdata$complex=="Plethodon.idaho.vandy",]
PredictionNEWprob <- predict(fitDFAarid,Species,type="prob") #calculates probability for each group
PredictionNEW <- predict(fitDFAarid,Species)
binded.dataRFPNW=cbind(Species, PredictionNEWprob,PredictionNEW)
binded.Predict=rbind(binded.dataRFPNW,binded.Predict)
write.table(binded.Predict[,c(20,32,34:36)], file="PredictDFAPNWDownOutsp.csv", sep=',', append=T)

}


####################
binded.Predict=c()
for (i in 1:100) {
  
PNWRF=c()
PNWRF=PNWdata[PNWdata$complex!="Prophysaon.coeruEW",]
C=PNWRF[PNWRF$group=="C",]
Csel=C[(sample(nrow(C), size=521, replace=T)),]
NC=PNWRF[PNWRF$group=="NC",]
PNWRF=rbind(Csel,NC)


fitDFAarid <- lda(group ~ bio1 + bio2 + bio3 + bio5 + bio7 + bio12 + bio15 + bio17 + taxon,
                  data=PNWRF)


Contribution=(fitDFAarid[[4]])
write.table(Contribution,file="fitDFAPNWDownsample.csv", sep=",", append=T)

fit.hatarid=predict(fitDFAarid)
binded.dataArid=c()
binded.dataArid=cbind(PNWRF, fit.hatarid$posterior) # bind initial data table with predicted values
write.table(binded.dataArid,file="bindedDataDFAPNWDownsample.csv",sep=",", append=T)

ctarid <- table(binded.dataArid$group, fit.hatarid$class)
diag(prop.table(ctarid, 1))
write.table(ctarid, file="confusionTableDFA_PNWDownsample.csv", sep=",",append=T)

Species=PNWdata[PNWdata$complex=="Prophysaon.coeruEW",]
PredictionNEWprob <- predict(fitDFAarid,Species,type="prob") #calculates probability for each group
PredictionNEW <- predict(fitDFAarid,Species)
binded.dataRFPNW=cbind(Species, PredictionNEWprob,PredictionNEW)
binded.Predict=rbind(binded.dataRFPNW,binded.Predict)
write.table(binded.Predict[,c(20,32,34:36)], file="PredictDFAPNWDownOutsp.csv", sep=',', append=T)

}

####################
binded.Predict=c()
for (i in 1:100) {

PNWRF=c()
fitRFPNW=c()
PNWRF=PNWdata[PNWdata$complex!="Salix.melanopsis",]
C=PNWRF[PNWRF$group=="C",]
Csel=C[(sample(nrow(C), size=236, replace=T)),]
NC=PNWRF[PNWRF$group=="NC",]
PNWRF=rbind(Csel,NC)


fitDFAarid <- lda(group ~ bio1 + bio2 + bio3 + bio5 + bio7 + bio12 + bio15 + bio17 + taxon,
                  data=PNWRF)


Contribution=(fitDFAarid[[4]])
write.table(Contribution,file="fitDFAPNWDownsample.csv", sep=",", append=T)

fit.hatarid=predict(fitDFAarid)
binded.dataArid=c()
binded.dataArid=cbind(PNWRF, fit.hatarid$posterior) # bind initial data table with predicted values
write.table(binded.dataArid,file="bindedDataDFAPNWDownsample.csv",sep=",", append=T)

ctarid <- table(binded.dataArid$group, fit.hatarid$class)
diag(prop.table(ctarid, 1))
write.table(ctarid, file="confusionTableDFA_PNWDownsample.csv", sep=",",append=T)

Species=PNWdata[PNWdata$complex=="Salix.melanopsis",]
PredictionNEWprob <- predict(fitDFAarid,Species,type="prob") #calculates probability for each group
PredictionNEW <- predict(fitDFAarid,Species)
binded.dataRFPNW=cbind(Species, PredictionNEWprob,PredictionNEW)
binded.Predict=rbind(binded.dataRFPNW,binded.Predict)
write.table(binded.Predict[,c(20,32,34:36)], file="PredictDFAPNWDownOutsp.csv", sep=',', append=T)

}

Predictions=read.csv(file="PredictDFAPNWDownOutsp.csv", header=T, row.names=NULL)

Predictions=Predictions[Predictions$group!="species.code",]
NC=Predictions[Predictions$group=="NC",]
NC[,5]=as.numeric(as.character(NC[,5]))
C=Predictions[Predictions$group=="C",]
C[,4]=as.numeric(as.character(C[,4]))
NC=droplevels(NC)
C=droplevels(C)

x11()
par(mfrow=c(1,2),mar=c(13,5,1,1))
boxplot(NC~complex, data=NC, las=2, main="NC - RF downsample100x", ylim=c(0,1))
abline(a=0.5, b=0, lty=3)
boxplot(C~complex, data=C, las=2, main="C", ylim=c(0,1))
abline(a=0.5, b=0, lty=3)
dev.copy2pdf(file="PredictDFAPNWDownsample100.pdf", horizontal=T)
dev.off()

