###this is to predict the type for unknown species

#load packages we will need
library(biomod2)
library(rworldmap)
library(rgdal) 
library(dismo)
library(SDMTools)
library(adehabitat)
library(randomForest)

#if installation of rgdal doesn't work, in ubuntu 14.04 and debian, run in terminal
#sudo apt-get install libproj-dev libgdal-dev and then try to reinstall
#
#

setwd("E:/collaborations/jack/R")

#load bioclim data and then select the area that will be used to project
bio1=raster("./cur_climate/bio1.bil") #Annual Mean Temperature
bio2=raster("./cur_climate/bio2.bil")
bio3=raster("./cur_climate/bio3.bil")
bio4=raster("./cur_climate/bio4.bil")
bio5=raster("./cur_climate/bio5.bil")
bio6=raster("./cur_climate/bio6.bil")
bio7=raster("./cur_climate/bio7.bil")
bio8=raster("./cur_climate/bio8.bil")
bio9=raster("./cur_climate/bio9.bil")
bio10=raster("./cur_climate/bio10.bil") #Mean Temperature of Warmest Quarter 
bio11=raster("./cur_climate/bio11.bil") #Mean Temperature of Coldest Quarter
bio12=raster("./cur_climate/bio12.bil") #Annual Precipitation
bio13=raster("./cur_climate/bio13.bil")
bio14=raster("./cur_climate/bio14.bil")
bio15=raster("./cur_climate/bio15.bil")
bio16=raster("./cur_climate/bio16.bil")
bio17=raster("./cur_climate/bio17.bil")
bio18=raster("./cur_climate/bio18.bil") #Precipitation of Warmest Quarter
bio19=raster("./cur_climate/bio19.bil") #Precipitation of Coldest Quarter

setwd("E:/collaborations/jack/R")
#clim=read.table("data_DFA_new.csv", header=T, sep=",")   ###Conaphe as NC
clim=read.table("data_DFA.csv", header=T, sep=",") ### Conaphe as C


PNWdata=cbind((as.matrix(extract(bio1,clim[,2:3]))),clim)
PNWdata=cbind((as.matrix(extract(bio2,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio3,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio4,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio5,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio6,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio7,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio8,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio9,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio10,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio11,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio12,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio13,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio14,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio15,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio16,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio17,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio18,clim[,2:3]))),PNWdata)
PNWdata=cbind((as.matrix(extract(bio19,clim[,2:3]))),PNWdata)

newcols=c("bio19","bio18","bio17","bio16","bio15","bio14","bio13","bio12","bio11","bio10","bio9","bio8",
          "bio7","bio6","bio5","bio4","bio3","bio2","bio1",colnames(clim))
colnames(PNWdata)<-newcols
#write.table(PNWdata, file="PNWdata_full.csv", sep=",")



#adjust the RF
setwd("E:/collaborations/jack/R/testAccuracy/Downsampling100RF_PNW")
memory.limit(size=50000)
binded.Predict=c()
for (i in 1:100) {
PNWRF=c()
fitRFPNW=c()
PNWRF=PNWdata[PNWdata$complex!="Ascaphus.montanus.truei",]
C=PNWRF[PNWRF$group=="C",]
Csel=C[(sample(nrow(C), size=567, replace=T)),]
NC=PNWRF[PNWRF$group=="NC",]
PNWRF=rbind(Csel,NC)

fitRFPNW <- randomForest(group ~ bio1 + bio2 + bio3 + bio5 + bio7 + bio12 + bio15 + bio17 + taxon,
                         data=PNWRF, importance=TRUE, ntree=5000, replace=T)

Contribution=fitRFPNW$importance
write.table(Contribution,file="fitRFPNWResamp3000_final.csv", sep=",", append=T)

PredictionPNW <- predict(fitRFPNW)
binded.dataRFPNW=c()
binded.dataRFPNW=cbind(PNWRF, PredictionPNW) # bind initial data table with predicted values
write.table(binded.dataRFPNW,file="binded.dataPNW_RF_resampl3000_final.csv", sep=",", append=T)

ctRFPNW <- table(binded.dataRFPNW$group, PredictionPNW)
diag(prop.table(ctRFPNW, 1))
write.table(ctRFPNW, file="confusionTableRF_PNWResampled3000_final.csv", sep=",",append=T)

Ascaphus=PNWdata[PNWdata$complex=="Ascaphus.montanus.truei",]
PredictionNEWprob <- predict(fitRFPNW,Ascaphus,type="prob") #calculates probability for each group
PredictionNEW <- predict(fitRFPNW,Ascaphus)
binded.dataRFPNW=cbind(Ascaphus, PredictionNEWprob,PredictionNEW)
binded.Predict=rbind(binded.dataRFPNW,binded.Predict)
write.table(binded.Predict, file="PredictAscaphus.csv", sep=',', append=T)
}
x11()
print(plot(binded.dataRFPNW$PredictionNEW, main="Prediction Ascaphus", beside=F) )
dev.copy(tiff,width = 1000, height = 1000, compression="none",file="Ascaphus.montanus.truei.tif")
dev.off()

####################
binded.Predict=c()
for (i in 1:100) {
  
PNWRF=c()
PNWRF=PNWdata[PNWdata$complex!="Conaphe.armataEW",]
C=PNWRF[PNWRF$group=="C",]
Csel=C[(sample(nrow(C), size=567, replace=T)),]
NC=PNWRF[PNWRF$group=="NC",]
PNWRF=rbind(Csel,NC)

fitRFPNW <- randomForest(group ~ bio1 + bio2 + bio3 + bio5 + bio7 + bio12 + bio15 + bio17 + taxon,
                         data=PNWRF, importance=TRUE, ntree=5000, replace=T)

Contribution=fitRFPNW$importance
write.table(Contribution,file="fitRFPNWResamp3000_final.csv", sep=",", append=T)

PredictionPNW <- predict(fitRFPNW)
binded.dataRFPNW=c()
binded.dataRFPNW=cbind(PNWRF, PredictionPNW) # bind initial data table with predicted values
write.table(binded.dataRFPNW,file="binded.dataPNW_RF_resampl3000_final.csv", sep=",", append=T)

ctRFPNW <- table(binded.dataRFPNW$group, PredictionPNW)
diag(prop.table(ctRFPNW, 1))
write.table(ctRFPNW, file="confusionTableRF_PNWResampled3000_final.csv", sep=",",append=T)

Chonaphe=PNWdata[PNWdata$complex=="Conaphe.armataEW",]
PredictionNEWprob <- predict(fitRFPNW,Chonaphe,type="prob") #calculates probability for each group
PredictionNEW <- predict(fitRFPNW,Chonaphe)
binded.dataRFPNW=cbind(Chonaphe, PredictionNEWprob,PredictionNEW)
binded.Predict=rbind(binded.dataRFPNW,binded.Predict)
write.table(binded.Predict, file="PredictConaphe.csv", sep=',', append=T)
}
x11()
print(plot(binded.dataRFPNW$PredictionNEW, main="Prediction Conaphe", beside=F) )
dev.copy(tiff,width = 1000, height = 1000, compression="none",file="Conaphe.armata.tif")
dev.off()

####################
binded.Predict=c()
for (i in 1:100) {
  
PNWRF=c()
PNWRF=PNWdata[PNWdata$complex!="Dicamptodon.ater.tene",]
C=PNWRF[PNWRF$group=="C",]
Csel=C[(sample(nrow(C), size=567, replace=T)),]
NC=PNWRF[PNWRF$group=="NC",]
PNWRF=rbind(Csel,NC)


fitRFPNW <- randomForest(group ~ bio1 + bio2 + bio3 + bio5 + bio7 + bio12 + bio15 + bio17 + taxon,
                         data=PNWRF, importance=TRUE, ntree=5000, replace=T)

Contribution=fitRFPNW$importance
write.table(Contribution,file="fitRFPNWResamp3000_final.csv", sep=",", append=T)

PredictionPNW <- predict(fitRFPNW)
binded.dataRFPNW=c()
binded.dataRFPNW=cbind(PNWRF, PredictionPNW) # bind initial data table with predicted values
write.table(binded.dataRFPNW,file="binded.dataPNW_RF_resampl3000_final.csv", sep=",", append=T)

ctRFPNW <- table(binded.dataRFPNW$group, PredictionPNW)
diag(prop.table(ctRFPNW, 1))
write.table(ctRFPNW, file="confusionTableRF_PNWResampled3000_final.csv", sep=",",append=T)

Dicampt=PNWdata[PNWdata$complex=="Dicamptodon.ater.tene",]
PredictionNEWprob <- predict(fitRFPNW,Dicampt,type="prob") #calculates probability for each group
PredictionNEW <- predict(fitRFPNW,Dicampt)
binded.dataRFPNW=cbind(Dicampt, PredictionNEWprob,PredictionNEW)
binded.Predict=rbind(binded.dataRFPNW,binded.Predict)
write.table(binded.Predict, file="PredictDicamp.csv", sep=',', append=T)
}
x11()
print(plot(binded.dataRFPNW$PredictionNEW, main="Prediction Dicampt", beside=F) )
dev.copy(tiff,width = 1000, height = 1000, compression="none",file="Dicamptodon.tif")
dev.off()

####################
binded.Predict=c()
for (i in 1:100) {
  
PNWRF=c()
PNWRF=PNWdata[PNWdata$complex!="Microtus.richardsoni",]
C=PNWRF[PNWRF$group=="C",]
Csel=C[(sample(nrow(C), size=377, replace=T)),]
NC=PNWRF[PNWRF$group=="NC",]
PNWRF=rbind(Csel,NC)

fitRFPNW <- randomForest(group ~ bio1 + bio2 + bio3 + bio5 + bio7 + bio12 + bio15 + bio17 + taxon,
                         data=PNWRF, importance=TRUE, ntree=5000, replace=T)

Contribution=fitRFPNW$importance
write.table(Contribution,file="fitRFPNWResamp3000_final.csv", sep=",", append=T)

PredictionPNW <- predict(fitRFPNW)
binded.dataRFPNW=c()
binded.dataRFPNW=cbind(PNWRF, PredictionPNW) # bind initial data table with predicted values
write.table(binded.dataRFPNW,file="binded.dataPNW_RF_resampl3000_final.csv", sep=",", append=T)

ctRFPNW <- table(binded.dataRFPNW$group, PredictionPNW)
diag(prop.table(ctRFPNW, 1))
write.table(ctRFPNW, file="confusionTableRF_PNWResampled3000_final.csv", sep=",",append=T)

Microtus=PNWdata[PNWdata$complex=="Microtus.richardsoni",]
PredictionNEWprob <- predict(fitRFPNW,Microtus,type="prob") #calculates probability for each group
PredictionNEW <- predict(fitRFPNW,Microtus)
binded.dataRFPNW=cbind(Microtus, PredictionNEWprob,PredictionNEW)
binded.Predict=rbind(binded.dataRFPNW,binded.Predict)
write.table(binded.Predict, file="PredictMicrotus.csv", sep=',', append=T)
}
x11()
print(plot(binded.dataRFPNW$PredictionNEW, main="Prediction Microtus", beside=F) )
dev.copy(tiff,width = 1000, height = 1000, compression="none",file="Microtus.tif")
dev.off()

####################
binded.Predict=c()
for (i in 1:100) {
  
PNWRF=c()
PNWRF=PNWdata[PNWdata$complex!="Plethodon.idaho.vandy",]
C=PNWRF[PNWRF$group=="C",]
Csel=C[(sample(nrow(C), size=567, replace=T)),]
NC=PNWRF[PNWRF$group=="NC",]
PNWRF=rbind(Csel,NC)

fitRFPNW <- randomForest(group ~ bio1 + bio2 + bio3 + bio5 + bio7 + bio12 + bio15 + bio17 + taxon,
                         data=PNWRF, importance=TRUE, ntree=5000, replace=T)

Contribution=fitRFPNW$importance
write.table(Contribution,file="fitRFPNWResamp3000_final.csv", sep=",", append=T)

PredictionPNW <- predict(fitRFPNW)
binded.dataRFPNW=c()
binded.dataRFPNW=cbind(PNWRF, PredictionPNW) # bind initial data table with predicted values
write.table(binded.dataRFPNW,file="binded.dataPNW_RF_resampl3000_final.csv", sep=",", append=T)

ctRFPNW <- table(binded.dataRFPNW$group, PredictionPNW)
diag(prop.table(ctRFPNW, 1))
write.table(ctRFPNW, file="confusionTableRF_PNWResampled3000_final.csv", sep=",",append=T)

Plethodon=PNWdata[PNWdata$complex=="Plethodon.idaho.vandy",]
PredictionNEWprob <- predict(fitRFPNW,Plethodon,type="prob") #calculates probability for each group
PredictionNEW <- predict(fitRFPNW,Plethodon)
binded.dataRFPNW=cbind(Plethodon, PredictionNEWprob,PredictionNEW)
binded.Predict=rbind(binded.dataRFPNW,binded.Predict)
write.table(binded.Predict, file="PredictPlethodon.csv", sep=',', append=T)
}
x11()
print(plot(binded.dataRFPNW$PredictionNEW, main="Prediction Plethodon", beside=F) )
dev.copy(tiff,width = 1000, height = 1000, compression="none",file="Plethodon.tif")
dev.off()


####################
binded.Predict=c()
for (i in 1:100) {
  
PNWRF=c()
PNWRF=PNWdata[PNWdata$complex!="Prophysaon.coeruEW",]
C=PNWRF[PNWRF$group=="C",]
Csel=C[(sample(nrow(C), size=521, replace=T)),]
NC=PNWRF[PNWRF$group=="NC",]
PNWRF=rbind(Csel,NC)

fitRFPNW <- randomForest(group ~ bio1 + bio2 + bio3 + bio5 + bio7 + bio12 + bio15 + bio17  + taxon,
                         data=PNWRF, importance=TRUE, ntree=5000, replace=T)

Contribution=fitRFPNW$importance
write.table(Contribution,file="fitRFPNWResamp3000_final.csv", sep=",", append=T)

PredictionPNW <- predict(fitRFPNW)
binded.dataRFPNW=c()
binded.dataRFPNW=cbind(PNWRF, PredictionPNW) # bind initial data table with predicted values
write.table(binded.dataRFPNW,file="binded.dataPNW_RF_resampl3000_final.csv", sep=",", append=T)

ctRFPNW <- table(binded.dataRFPNW$group, PredictionPNW)
diag(prop.table(ctRFPNW, 1))
write.table(ctRFPNW, file="confusionTableRF_PNWResampled3000_final.csv", sep=",",append=T)

Prophy=PNWdata[PNWdata$complex=="Prophysaon.coeruEW",]
PredictionNEWprob <- predict(fitRFPNW,Prophy,type="prob") #calculates probability for each group
PredictionNEW <- predict(fitRFPNW,Prophy)
binded.dataRFPNW=cbind(Prophy, PredictionNEWprob,PredictionNEW)
binded.Predict=rbind(binded.dataRFPNW,binded.Predict)
write.table(binded.Predict, file="PredictProphy.csv", sep=',', append=T)
}
x11()
print(plot(binded.dataRFPNW$PredictionNEW, main="Prediction Prophy", beside=F) )
dev.copy(tiff,width = 1000, height = 1000, compression="none",file="Prophysaon.coer.tif")
dev.off()

####################
binded.Predict=c()
for (i in 1:100) {

PNWRF=c()
fitRFPNW=c()
PNWRF=PNWdata[PNWdata$complex!="Salix.melanopsis",]
C=PNWRF[PNWRF$group=="C",]
Csel=C[(sample(nrow(C), size=236, replace=T)),]
NC=PNWRF[PNWRF$group=="NC",]
PNWRF=rbind(Csel,NC)

fitRFPNW <- randomForest(group ~ bio1 + bio2 + bio3 + bio5 + bio7 + bio12 + bio15 + bio17 + taxon,
                         data=PNWRF, importance=TRUE, ntree=5000, replace=T)

Contribution=fitRFPNW$importance
#write.table(Contribution,file="fitRFPNWResamp3000_final.csv", sep=",", append=T)

PredictionPNW <- predict(fitRFPNW)
binded.dataRFPNW=c()
binded.dataRFPNW=cbind(PNWRF, PredictionPNW) # bind initial data table with predicted values
#write.table(binded.dataRFPNW,file="binded.dataPNW_RF_resampl3000_final.csv", sep=",", append=T)

ctRFPNW <- table(binded.dataRFPNW$group, PredictionPNW)
diag(prop.table(ctRFPNW, 1))
#write.table(ctRFPNW, file="confusionTableRF_PNWResampled3000_final.csv", sep=",",append=T)

Salix=PNWdata[PNWdata$complex=="Salix.melanopsis",]
PredictionNEWprob <- predict(fitRFPNW,Salix,type="prob") #calculates probability for each group
PredictionNEW <- predict(fitRFPNW,Salix)
binded.dataRFPNW=cbind(Salix, PredictionNEWprob,PredictionNEW)
binded.Predict=rbind(binded.dataRFPNW,binded.Predict)
write.table(binded.Predict, file="PredictSalix.csv", sep=',', append=T)
}

x11()
print(plot(binded.dataRFPNW$PredictionNEW, main="Prediction Salix", beside=F) )
dev.copy(tiff,width = 1000, height = 1000, compression="none",file="Salix.tif")
dev.off()


Asc=read.csv(file="PredictAscaphus.csv", header=T, row.names=NULL)
Cona=read.csv(file="PredictConaphe.csv", header=T, row.names=NULL)
Dic=read.csv(file="PredictDicamp.csv", header=T, row.names=NULL)
Microt=read.csv(file="PredictMicrotus.csv", header=T, row.names=NULL)
Plethod=read.csv(file="PredictPlethodon.csv", header=T, row.names=NULL)
Prophys=read.csv(file="PredictProphy.csv", header=T, row.names=NULL)
Salix=read.csv(file="PredictSalix.csv", header=T, row.names=NULL)

Predictions=rbind(Asc, Cona, Dic, Microt, Plethod, Prophys, Salix)
Predictions=Predictions[Predictions$group!="species.code",]
NC=Predictions[Predictions$group=="NC",]
NC[,37]=as.numeric(as.character(NC[,37]))
C=Predictions[Predictions$group=="C",]
C[,36]=as.numeric(as.character(C[,36]))
NC=droplevels(NC)
C=droplevels(C)

x11()
par(mfrow=c(1,2),mar=c(13,5,1,1))
boxplot(NC~complex, data=NC, las=2, main="NC - RF downsample100x", ylim=c(0,1))
abline(a=0.5, b=0, lty=3)
boxplot(C~complex, data=C, las=2, main="C", ylim=c(0,1))
abline(a=0.5, b=0, lty=3)


